------------------------------------------------------------------
-- PROJECT:     HiCoVec Processor
--
-- ENTITY:      DATATYPES
--
-- PURPOSE:     Datatypes used in the HiCoVec
-- 
-- Created by: Harald Manske
--
-- Prof. Gundolf Kiefer
-- Hochschule Augsburg
--
-- 
--
-- 
-- DATE CREATE: 
-- LAST CHANGE: 2008-12-19 FROM: Andreas Mueller
-- VERSION:     0.1
-----------------------------------------------------------------



library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

use work.cfg.all;

package datatypes is
	type vectordata_type is array (k-1 downto 0) of std_logic_vector(31 downto 0);
end datatypes;

