;SCOTCH-RACE v1.1
;Key- and Rotation-Button Version
;(c) 2009 Andreas Mueller, Hochschule Augsburg
;modified 02/2009 by Jakob Golus, Hochschule Augsburg
;geaendert 06/2009 fuer HICOSIM, Zeilen: [11/12, 25/26, 30/31 , 44/45 fuer strasse] 62, 290

; Leere Strasse mit roten Curps passend für 16 Vektoreinheiten in VGA-RAM auf Zeile 201 Laden:
	.org 0x3f40
	;.org 0x2000
STRROT:	
	.dc 0x66666666	;reine 6
	.dc 0x66666666
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x66666666 ;reine 6
	.dc 0x66666666
; Leere Strasse mit weissen Curps passend für 16 Vektoreinheiten in VGA-RAM auf Zeile 201+16 Laden:
	.org 0x3f50
	;.org 0x2028
STRWEI:	.dc 0x00000000	;reine nullen
	.dc 0x00000000
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x00000000  ;reine nullen
	.dc 0x00000000
;rotes Auto an Adresse 0x400
	.org 0x400
AUTO:	.dc 0x66666666
	.dc 0xFF7667FF
	.dc 0xFF7667FF
	.dc 0x77666677
	.dc 0xFF6666FF
	.dc 0xFF6666FF
	.dc 0x76666667
	.dc 0x76666667
	.dc 0x77777777
;Variablen:
POINTCNT: .dc 0x0
LIFECNT:  .dc 0x5
STEPSWE:  .dc 0x4	;Zähler für 4 mal Tastendruck Button West
STEPSEA:  .dc 0x4	;Zähler für 4 mal Tastendruck Button EAST
KLEECNT:  .dc 48		;Alle 24 Zeilen ein Kleeblatt		##### CHANGE: 0 to 48
BOMBCNT:  .dc 32	;Alle 16 Zeilen eine Bombe
BOMBCMP:  .dc 0x77FFF777	;Vergleich mit mittlerer Bombenzeile
KLEECMP:  .dc 0x77777577	;Vergleich mit 1. Kleezeile

; Grüner Hintergrund aus 16 Zeichen grün/grün in VGA-RAM auf Zeile 201+32
	.org 0x3f60
;           "0123456789ABCDEF
BACKGR:	.dc "t    t    t      " (0xD,0x5)

TITLE1:	.dc " SCOTCH          " (0xf,0x5)
TITLE2:	.dc " RACE     LIVES: " (0x6,0x5)
TITLE3: .dc " RACE            " (0x6,0x5)
POINTS:	.dc " POINTS:         " (0xf,0x5)
WON:	.dc "  YOU HAVE WON   " (0x0,0x6)
LOST:	.dc "   GAME OVER     " (0x0,0x6)
BEGIN:	.dc "   PRESS START   " (0x0,0x6)
LIVES:	.dc "                 " (0x6,0x5)

;Programmstart
	.org 0x0
	.start
START5: 
	LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + START5]

;###### auskommentiert
START:	
	;OR A, 0, 0xFFFF
;WAIT10:	
	;SUB A, A, 1
		;JNZ [0 + WAIT10]
		
		;OR A, 0, 0xFFFF
;WAIT11:	
	;SUB A, A, 1
		;JNZ [0 + WAIT11]
		
		;OR A, 0, 0xFFFF
;WAIT12:	
	;SUB A, A, 1
		;JNZ [0 + WAIT12]
;###### auskommentiert

	
	OR X, 0, BACKGR		;Adresse von Hintergrund in X laden
	VLD R10, [0 + X]	;Hintergrund in R10 laden

	OR X, 0, STRWEI		;Adresse von Straße weiß in X laden
	VLD R8, [0 + X]		;Straße weiß in R8 laden

	OR X, 0, STRROT		;Adresse von Hintergrund in X laden
	VLD R9, [0 + X]		;Straße rot in R9 laden	

	OR Y, 0, 0x3F		;Schleife 63x durchlaufen
	OR X, 0, 0x43E0		;Adresse der letzten ASCII Zeile laden
BACKDR:	
	VST [0 + X], R10	;Bildschirm mit Hintergrund füllen
	SUB X, X, 0x10
	SUB Y, Y, 0x1
	JNZ [0 + BACKDR]
;Titel Scotch Race schreiben:	
	OR A, 0, LIVES		;Adresse von Lives
	VLD R10, [0 + A]
	OR A, 0, 0x4000
	VST [0 + A], R10	;Titel 1 schreiben
	
	OR A, 0, TITLE1		;Adresse von SCOTCH
	VLD R10, [0 + A]
	OR A, 0, 0x400E
	VST [0 + A], R10	;Titel 1 schreiben

	OR A, 0, LIVES		;Adresse von Lives
	VLD R10, [0 + A]
	OR A, 0, 0x4018
	VST [0 + A], R10	;Titel 1 schreiben
	
	OR A, 0, TITLE3		;Adresse von RACE
	VLD R10, [0 + A]
	OR A, 0, 0x4015
	VST [0 + A], R10	;Titel 1 schreiben

;Warten auf drücken des Startknopfes
	OR A, 0, BEGIN		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4174
	VST [0 + A], R10	;Titel 1 schreiben
START0: 
	LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + START0]
; Beginn mit Straßenaufbau
	OR X, 0, 0x214C		;Adresse der 9.  Zeile + Offseet laden
	OR Y, 0, 12		;Schleife 10x durchlaufen
STRDR:	
	OR A, 0, 8		;nach 10 Zeilen Farbe wechseln	
STRRDR:	
	VST [0 + X], R9		;Straße mit roten Curps in VGA RAM
	ADD X, X, 0x28
	SUB A, A, 1
	JNZ [0 + STRRDR]
	OR A, 0, 8		;nach 10 Zeilen Farbe wechseln	
STRWDR:	
	VST [0 + X], R8		;Straße mit weissen Curps in VGA RAM
	ADD X, X, 0x28
	SUB A, A, 1
	JNZ [0 + STRWDR]
	SUB Y, Y, 1
 	JNZ [0 + STRDR]
	OR X, 0, 0x14		;Auto auf Straßenmitte
;Testweise Bombe und Kleeblatt setzen
	OR A, 0, 0x756B
	ST [0 + 0x4060],A 
	OR A, 0, 0x7F62		;Bombe zeichnen
	ST [0 + 0x41A2],A 
;Sraße durchshiften
SHIFT:	
	LD A, [0 + 0xFFFF]		;Taster laden
	AND A, A, 0x00F0	;Buttons maskieren
	SUB 0, A, 0x10		;auf WEST Taster prüfen
	JNZ [0 + NoLeft]

;Auto verlangsamen...
	LD A, [0 + STEPSWE]	;5x Taster bis Schritt...
	SUB A, A, 1
	ST [0 + STEPSWE], A	;Zähler rücksichern
	LD A, [0 + STEPSWE]	;5x Taster bis Schritt...
	JNZ [0 + NoLeft]	

	OR A, 0, 0x4		;Zähler auf 5
	ST [0 + STEPSWE], A	;Zähler rücksichern
	nop
	SUB X, X, 1
	SUB 0, X, 13		;Pruefen ob linker rand erreicht
	JNZ [0 + NoLeft]
	OR X, 0, 14
	
NoLeft:	
	LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x00F0	;Buttons maskieren
	SUB 0, A, 0x80		;auf EAST Taster prüfen
	JNZ [0 + NoRigh]
;Auto verlangsamen...
	LD A, [0 + STEPSEA]	;5x Taster bis Schritt...
	SUB A, A, 1
	ST [0 + STEPSEA], A	;Zähler rücksichern
	LD A, [0 + STEPSEA]	;5x Taster bis Schritt...
	JNZ [0 + NoRigh]	

	OR A, 0, 0x4		;Zähler auf 5
	ST [0 + STEPSEA], A	;Zähler rücksichern
	nop
	ADD X, X, 1
	SUB 0, X, 26		;Pruefen ob rechter rand erreicht
	JNZ [0 + NoRigh]
	OR X, 0, 25
NoRigh:
;Bombe legen:
	LD A, [0 + BOMBCNT]	;Zähler...
	SUB A, A, 1
	ST [0 + BOMBCNT], A	;Zähler rücksichern
	LD A, [0 + BOMBCNT]	;5x Taster bis Schritt...
	JNZ [0 + NoBomb]	

	OR A, 0, 64		;Zähler auf 16
	ST [0 + BOMBCNT], A	;Zähler rücksichern
	nop
	OR A, 0, 0x7F62		;Bombe zeichnen
	ST [X + 0x4028],A 
	nop
NoBomb:
;Kleeblatt legen:
	LD A, [0 + KLEECNT]	;Zähler...
	SUB A, A, 1
	ST [0 + KLEECNT], A	;Zähler rücksichern
	LD A, [0 + KLEECNT]	;5x Taster bis Schritt...
	JNZ [0 + NoKlee]	

	OR A, 0, 128		;Zähler auf 128
	ST [0 + KLEECNT], A	;Zähler rücksichern
	nop
	OR A, 0, 0x756B		;Kleeblatt zeichnen
	ST [X + 0x4028],A 
	nop
	
NoKlee:
	;letzte Zeile rücksichern
	OR A, 0, 0x3F18		;Adresse der letzten Zeile der Straße: ersten 8 Zeichen
	VLD R0, [0 + A]		;Obige Zeile sichern
	OR A, 0, 0x3F20		;Adresse der letzten Zeile der Straße: Zeichen 9 bis 24
	VLD R2, [0 + A]		;Obige Zeile sichern
	OR A, 0, 0x3F30		;Adresse der letzten Zeile der Straße: Zeichen 25 bis 40
	VLD R4, [0 + A]		;Obige Zeile sichern
	OR Y, 0, 191		;192x pro Bildschirm
	
SHIFDO:
	;obere Zeile Laden
	SUB A, A, 0x40		;Springe in vorige Zeile an denAnfang (28h+10h+8h=40h)
	VLD R1, [0 + A]		;Lade die ersten 8 Zeichen nach R1
	ADD A, A, 0x8		;Index auf zweiten Bereichsanfang ab Zeichen 9 stellen
	VLD R3, [0 + A]		;Lade Zeichen 9 bis 24 nach R3
	ADD A, A, 0x10		;Index auf dritten Bereichsanfang ab Zeichen 25 stellen
	VLD R5, [0 + A]		;Lade Zeichen 25 bis 40 nach R5
	
	;aktuelle Zeile mit geladener Zeile überschreiben
	ADD A, A, 0x10		;Springe in nächste Zeile
	VST [0 + A], R1		;Überschreibe Zeichen 1 bis 8 der vorherigen Zeile
	ADD A, A, 0x8		;Index auf zweiten Bereichsanfang ab Zeichen 9 stellen
	VST [0 + A], R3		;Überschreibe Zeichen 9 bis 24 der vorherigen Zeile
	ADD A, A, 0x10		;Index auf dritten Bereichsanfang ab Zeichen 25 stellen
	VST [0 + A], R5		;Überschreibe Zeichen 25 bis 40 der vorherigen Zeile
	
	SUB A, A, 0x28		;Springe in nächste Zeile
	SUB Y, Y, 1			;Schleifenzähler dekrementieren
	JNZ [0 + SHIFDO]	;Falls Zähler noch nicht 0, dann nochmal schieben
	
	;Rückgesicherte letzte Zeile als erste Zeile schreiben
	SUB A, A, 0x18		;Index auf Zeilenanfang setzen
	VST [0 + A], R0		;Zeichen 1-8 schreiben
	ADD A, A, 0x8		;Index auf Zeichen 9 setzen
	VST [0 + A], R2		;Zeichen 9 bis 24 schreiben
	ADD A, A, 0x10		;Index auf Zeichen 25 setzen
	VST [0 + A], R4		;Zeichen 25 bis 40 schreiben

;Warteschleife
	OR A, 0, 3000;                         ;3000        ;##### CHANGE 
WAIT1:	
	SUB A, A, 1
	JNZ [0 + WAIT1]

	OR A, 0, 0x7700
	ST [0 + 0x43CE], A	;Autozeile grau überzeichnen
	ST [0 + 0x43CF], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D0], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D1], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D2], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D3], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D4], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D5], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D6], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D7], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D8], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D9], A	;Autozeile grau überzeichnen
;Auto auf Strecke zeichnen (Zeile 192-200)
	LD A, [0 + 0x400]
	ST [X + 0x3DB0], A
	LD A, [0 + 0x401]
	ST [X + 0x3DD8], A
	LD A, [0 + 0x402]
	ST [X + 0x3E00], A
	LD A, [0 + 0x403]
	ST [X + 0x3E28], A
	LD A, [0 + 0x404]
	ST [X + 0x3E50], A
	LD A, [0 + 0x405]
	ST [X + 0x3E78], A
	LD A, [0 + 0x406]
	ST [X + 0x3EA0], A
	LD A, [0 + 0x407]
	ST [X + 0x3EC8], A
	LD A, [0 + 0x408]
	ST [X + 0x3EF0], A
	LD A, [0 + 0x408]
;Suchen nach Kleeberuehrung
	LD A, [X + 0x3D88]	;Eine Zeile genau über Auto
	LD Y, [0 + KLEECMP]	;Lade Vergleichszeile
	SUB 0, A, Y		;Vergleiche
	JNZ [0 + NoKleeCmp]
	LD A,[0 + POINTCNT]	;Punktezähler in A
	ADD A, A, 1		;Addiere Punkt
	ST [0 + POINTCNT], A	;Punkte Rückschreiben
	nop
NoKleeCmp:
;Suchen nach Bombenberuehrung
	LD A, [X + 0x3D88]	;Eine Zeile genau über Auto
	LD Y, [0 + BOMBCMP]	;Lade Vergleichszeile
	SUB 0, A, Y		;Vergleiche
	JNZ [0 + NoBombCmp]
	LD A,[0 + LIFECNT]	;Lebenszähler in A
	SUB A, A, 1		;Subtrahiere Leben
	ST [0 + LIFECNT], A	;Leben Rückschreiben
	nop
NoBombCmp:
; Titel und Punkte Schreiben
	OR A, 0, POINTS		;Adresse von Punkte
	VLD R10, [0 + A]
	OR A, 0, 0x4000
	VST [0 + A], R10	;Points schreiben
	
	OR A, 0, LIVES		;Adresse von Lives
	VLD R10, [0 + A]
	OR A, 0, 0x4018
	VST [0 + A], R10	;Titel 1 schreiben
	
	OR A, 0, TITLE1		;Adresse von Scotch
	VLD R10, [0 + A]
	OR A, 0, 0x400E
	VST [0 + A], R10	;Titel 1 schreiben

	OR A, 0, TITLE2		;Adresse von Race
	VLD R10, [0 + A]
	OR A, 0, 0x4015
	VST [0 + A], R10	;Titel 1 schreiben
	
	LD A,[0 + POINTCNT]	;Punktezähler in A
	SUB 0, A, 10
	JZ [0 + Winner]		;Wenn 10 Punkte dann Gewonnen
	ADD A, A, 0x5F30	;Aus Zahl ASCII erstellen
	ST [0 + 0x4009], A	;Punte schreiben

	LD A,[0 + LIFECNT]	;Lebenszähler in A
	JZ [0 + Looser]		;Wenn 0 Leben dann Verloren
	ADD A, A, 0x5630	;Aus Zahl ASCII erstellen
	ST [0 + 0x4026], A	;Leben schreiben

	
	JMP [0 + SHIFT]		;Dauerschleife	

Winner:	
	OR A, 0, WON		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4174
	VST [0 + A], R10	;Titel 1 schreiben
RESTART1: 
	LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + RESTART1]
	OR A, 0, 0		;Addiere Punkt
	ST [0 + POINTCNT], A	;Punkte Rücksetzen
	nop
	OR A, 0, 5		;Addiere Punkt
	ST [0 + LIFECNT], A	;Leben Rücksetzen
	nop	
	JMP [0 + START]
Looser: 
	OR A, 0, LOST		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4174
	VST [0 + A], R10	;Titel 1 schreiben
RESTART2: 
	LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + RESTART2]
	OR A, 0, 0		;Addiere Punkt
	ST [0 + POINTCNT], A	;Punkte Rücksetzen
	nop
	OR A, 0, 5		;Addiere Punkt
	ST [0 + LIFECNT], A	;Leben Rücksetzen
	nop	
	JMP [0 + START]
ENDE:	
	HALT
	.end
