/*!errors_and_warnings.h
 *  In this file are all errors and warnings declered 
 *
 *  @author Eggenmueller Bernd , Juergen Schmidt
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */

//Warnings
void War_NoStart();
void War_SameAdresses(int start1, int end1, int start2, int end2);

//Errors
void Err_NoCode();
void Err_syntax(char* msg,int lineno,char* text);
void Err_DestFile();
void Err_SrcFile();
void Err_UnknownOption(char opt);
void Err_Out();
void Err_ReadSrc(char* file);
void Err_NoSrc();
void Err_TooMuchSourceFiles(int begin,int end,char **files);
void Err_TooMochStart(int anz);
void Err_NoSuchSec(int section_number);
void Err_LabelNotExist(char* label_name);
void Err_ParallelFailure(int line);

