
struct cons;

union item {
  int i;
  struct cons *c;
};

struct cons {
  union item car;
  union item cdr;
};

struct cons CONSES[100];
struct cons NIL = {0, 0};
int alloc_offset = 0;

struct cons *new_cons (){
  return &(CONSES[alloc_offset++]);
}

struct cons *cons(union item car, union item cdr){
  struct cons *c = new_cons();
  c->car = car;
  c->cdr = cdr;
  return c;
}

int reduce(int (*fun)(int acc, int next), struct cons *list){
  struct cons *c;
  int acc = 0;
  acc = list->car.i;
  list = list->cdr.c;
  for(c = list; c != &NIL; c = c->cdr.c){
    acc = fun(acc, list->car.i);
  }
  return acc;
}

int add2i(int x, int y){
  return y + x;
}

int main(void){
  struct cons *c;
  union item u;
  union item v;
  int i;

  NIL.car.c = &NIL;
  NIL.cdr.c = &NIL;

  u.i = 0;
  v.c = &NIL;
  c = cons(u, v);
  for (i = 1; i < 30; i++){
    u.i = i;
    v.c = c;
    c = cons(u, v);
  }
  return reduce(add2i, c);

}
