#!/bin/sh

HC_CFLAGS=""
HC_CC="./xgcc"
HICOSIM_DIR="~/HiCoSim"


function build_gcc(){
	s="$(echo $1|sed -e "s/.c/.s/")"
	S="$(echo $1|sed -e "s/.c/.S/")"
	asm="$(echo $1|sed -e "s/.c/.asm/")"
	$HC_CC $HC_CFLAGS -S $1 &&
        cat libgcc.s > $S &&
        cat $s >> $S && 
        perl -pi -e 's/^	/        /g' $S &&
        /bin/cp -f $S $asm &&
        echo " ">> $asm && 
        echo .end >> $asm &&
	/bin/cp $asm "$HICOSIM_DIR"/gcc_output.asm
}
