; ##### test_scalarunit.asm ############################
; Vergleich zwischen skalarer Einheit und Vektoreinheit
; siehe: test_vectorunit.asm 
; ######################################################

.org 0x00
.start

	OR Y, 0, 0 	;Zaehler i auf 0
LOOP:
	LD A, [Y + VEC0]	;VEK1[i] in A laden
	LD X, [Y + VEC1]	;VEK2[i] in X laden
	ADD A, A, X		;A + X in A speichern
	ST [Y + RESULT], A 	;ERG[i] speichern
	INC Y, Y			;Zaehler inkrementieren
	SUB 0, Y, 16		;vgl. Zaehler mit 16
	JNZ [0 + LOOP]	;springe, wenn Zaehler < 16 
	HALT

	; insgesamt 112 Befehle - Vektoreinheit: 7 Befehle!

.org 0xff
VEC0:
	.dc 1
	.dc 2
	.dc 3
	.dc 4
	.dc 5
	.dc 6
	.dc 7
	.dc 8
	.dc 9
	.dc 10
	.dc 11
	.dc 12
	.dc 13
	.dc 14
	.dc 15
	.dc 16

VEC1:
	.dc 16
	.dc 15
	.dc 14
	.dc 13
	.dc 12
	.dc 11
	.dc 10
	.dc 9
	.dc 8
	.dc 7
	.dc 6
	.dc 5
	.dc 4
	.dc 3
	.dc 2
	.dc 1
	

.org 0xfff
RESULT:
	.dc 0

.end
