//package hicosim;
//
//import hicosim.components.frontend.iListenerFrontend;
//import hicosim.components.plugins.*;
//
///**
// * @author Andi,Luca 
// * @version 04-07-2009
// * 
// * Interface, welches von Engine implementiert wird.
// * Sinn: Alle Clients (GUI/Console) sollen nur das Interface instanziieren anstatt direkt eine Engine.
// * Die Methoden in diesem Interface stellen alle Moeglichkeiten dar, mit denen ein Client auf die Engine zugreifen
// * kann/darf.
// 
// */
//
//public interface IEngine {
//	
//	
//	//CALLBACK :
//	public void addListener(iListenerFrontend listener) throws Exception;
//	public void displayConsole(String message, boolean error);
//	
//	public void displayMemoryChanges(String changes);
//	public void displayUsage(double cpuAverage, double memoryAverage);	
//	
//	public void displayScalarRegChanges(int valOfA, int valOfX, int valOfY);
//	public void setJTableVectorCpuRegisterOverviewSize(int rows, int columns);
//	public void displayVectorRegChanges(int [][]vRegs);
//	public void displayStatusRegister(boolean zero, int carry); //carry = 1 or 0
//	
//	public void addPlugin(IPlugin newPlugin);
//	
//	
////	getProcessor()
////	GETmEMORY()
//	
//	//load the objectfile
//	public String loadObjectFile(String PATH) throws Exception; //in memory...
//	public boolean isObjectFileLoaded();
//	
//	public void reset() throws Exception;	
//	public void resetMemory() throws Exception;	
//	public void run() throws Exception;	
//	public void step() throws Exception;
//	public void continueRun() throws Exception;	
//	
//	public void interrupt()throws Exception;
//	
//	public String setBreakpoint(String paramBreak) throws Exception;
//	public int getAddressOfLabel(String label) throws Exception;
//	
//	
//	public String getRegs() throws Exception;
//	public int getIP() throws Exception;
//	public String getLabels() throws Exception;
//	public String getStats() throws Exception;
//	public String getConfig() throws Exception; //String representation
//	public String getAboutMessage();
//	
//	//memory:
//	public int getMemoryContentAt(int address) throws Exception;
//	public void setMemory(int address, int value) throws Exception;
//		
//	//sourcefile:
//	public String readSourcefile(String PATH) throws Exception;
//	//muss sein fuer list Kommando:
//	public String getSourceCodeLines() throws Exception; //MERKT SICH AKTUELLE SRC_DATEI
//	public String getSourceCodePATH() throws Exception;			// UND DESSEN PFAD..
//	public void writeToSourcefile(String PATH, String text) throws Exception;
//	
//	
//	public String setConfiguration(String paramsConfig) throws Exception;
//	
//	public String disas() throws Exception;
//	
//	//execute external process:
//	public String execute(String cmd) throws Exception;
//	
//}
