package hicosim.components.backend.processor.enums;

/**
 * Enumeration of types of wordwidth.
 * 
 * @author Luca Calchera
 */
public enum VecWord{
	BYTE(8,32),WORD(16,16),DOUBLEWORD(32,8),QUADWORD(64,4);
	private int value;
	private int div;
	
	VecWord(int value,int div) {
		this.value = value;
		this.div = div;
	}
	public int getValue() {
		return value;
	}
	public int getDiv() {
		return div;
	}
}	